Index: soft/giet_vm/giet_fat32/fat32.c
===================================================================
--- soft/giet_vm/giet_fat32/fat32.c	(revision 569)
+++ soft/giet_vm/giet_fat32/fat32.c	(revision 587)
@@ -954,191 +2746,384 @@
 unsigned int p       = procid & ((1<<P_WIDTH)-1);
 if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _scan_directory() : P[%d,%d,%d] enters for %s\n",
-      x, y, p, file_name );
-#endif
-
-    unsigned int  i;
-    for( i = 0 ; i < 32 ; i++ ) dir_entry[i]  = 0;
-    for( i = 0 ; i < 14 ; i++ ) name_entry[i] = 0;
-
-    // load first sector from DATA region into FAT cache
-    // other sectors will be loaded inside loop as required
-    if( _fat_ioc_access( use_irq,
-                         1,               // read
-                         lba,
-                         (unsigned int)_fat.fat_cache,
-                         1 ) )            // one sector
-    {
-        _printf("[\nFAT ERROR] in _scan_directory() : cannot read sector %x\n",
-                lba );
+_printf("\n[DEBUG FAT] _fat_open() : P[%d,%d,%d] enters for path <%s> / "
+        " create = %d / read_only = %d\n",
+        x, y, p, pathname , create , read_only );
+#endif
+
+    // checking FAT initialised
+    if( _fat.initialised != FAT_INITIALISED )
+    {
+        _printf("\n[FAT ERROR] in _fat_open() : FAT not initialised\n");
         return -1;
     }
-    _fat.cache_lba = lba;
-
-#if GIET_DEBUG_FAT 
-if ( (_get_proctime() > GIET_DEBUG_FAT) && (GIET_DEBUG_FAT & 0x1) )
-_display_fat_cache();
-#endif
-
-    // in this loop we scan all names in the directory identified by cluster index 
-    // - the offset increment is an integer number of directory entry (32 bytes)
-    // - the exit condition is success (name found) or failure (end of directory) 
-    while( found == 0 )
-    {
-        // load a new sector if required
-        if (offset >= 512)              
-        {
-            if ( block_id )           // not a new cluster
-            {
-                lba += 1;
-                block_id --;
-            }
-            else					  // get next cluster
-            {
-                cluster = _get_next_cluster( use_irq , cluster );
-
-                if ( cluster >= END_OF_CHAIN_CLUSTER  ) return END_OF_CHAIN_CLUSTER;
-
-                lba      = cluster_to_lba(cluster);
-                block_id = _fat.sectors_per_cluster;
-            }
-            if( _fat_ioc_access( use_irq,
-                                 1,               // read
-                                 lba, 
-                                 (unsigned int)_fat.fat_cache,
-                                 1 ) )            // one sector
-            {
-                _printf("\n[FAT ERROR] in _scan_directory() : cannot read sector %x\n",
-                        lba);
-                return -1;
-            }
-            _fat.cache_lba = lba;
-            block_id--;
-            offset = offset % 512;
-        }
-
-        // store the directory entry pointed by offset in dir_entry buffer,
-        // if it a possible candidate for the searched name
-
-        attr = _read_entry( DIR_ATTR, _fat.fat_cache + offset, 0);   
-        ord  = _read_entry( LDIR_ORD, _fat.fat_cache + offset, 0);
-
-        if ( is_sfn == 1 )		                  // searched name is short
-        {
-            if      ( (ord != FREE_ENTRY ) &&
-                      (ord != NO_MORE_ENTRY) &&
-                      (attr == ATTR_LONG_NAME_MASK) )    // EXT entry : skipped
-            {
-                offset     = offset + ((ord & 0xF) * DIR_ENTRY_SIZE);
-            }
-            else if ( (attr != ATTR_LONG_NAME_MASK) && 
-                      (ord  != FREE_ENTRY) && 
-                      (ord  != NO_MORE_ENTRY ) )         // SFN entry : to be checked
-            {
-                memcpy( dir_entry, _fat.fat_cache + offset, DIR_ENTRY_SIZE );    
-
-                get_name_from_short( dir_entry, name_entry );
-
-                if ( _strncmp( (char*)sfn_string, 
-                               (char*)name_entry, 13 ) == 0 )  // short name found
-                {
-                    found = 1;
-                }
-                else
-                {
-                    offset = offset + DIR_ENTRY_SIZE;
-                }
-            }
-            else if (ord == NO_MORE_ENTRY )              // end of directory : return
-            {
-                return END_OF_CHAIN_CLUSTER;
-            }
-        }
-        else                                      // searched name is long
-        {
-            if( (attr == ATTR_LONG_NAME_MASK) && 
-                (ord != FREE_ENTRY) &&
-                (ord != NO_MORE_ENTRY) )                 // EXT entry : to be checked
-            {
-                memcpy( dir_entry, _fat.fat_cache + offset, DIR_ENTRY_SIZE );
-
-                get_name_from_long( dir_entry, name_entry );
-
-                unsigned shift = ((ord & 0xf) - 1) * 13;
-                if ( _strncmp( (char*)(file_name + shift), 
-                               (char*)name_entry, 13 ) == 0 )  // matching EXT
-                {
-                    if( (ord & 0xf) == 1 )                    // long name found 
-                    {
-                        long_name_found = 1;
-                    }
-                }
-                offset = offset + DIR_ENTRY_SIZE;
-            }
-            else if( (attr != ATTR_LONG_NAME_MASK) && 
-                     (ord  != FREE_ENTRY) && 
-                     (ord  != NO_MORE_ENTRY) )
-            {
-                if ( long_name_found )                   // LFN entry
-                {
-                    memcpy( dir_entry, _fat.fat_cache + offset, DIR_ENTRY_SIZE );
-                    found = 1;
-                }
-                else                                     // SFN entry: must be skipped
-                {
-                    offset = offset + DIR_ENTRY_SIZE;
-                }
-            }
-            else if (ord == NO_MORE_ENTRY )				 // end of directory : return
-            {
-                return END_OF_CHAIN_CLUSTER;
-            }
-        }
-    }  // end while
-
-    // returns cluster index
-    *file_size       = _read_entry( DIR_FILE_SIZE, dir_entry, 1 );
-    *lba_dir_entry   = lba;
-    searched_cluster = (_read_entry( DIR_FST_CLUS_HI, dir_entry, 1 ) << 16) |
-                       (_read_entry( DIR_FST_CLUS_LO, dir_entry, 1 )      ) ;
+
+    // takes the lock
+    _spin_lock_acquire( &_fat.fat_lock );
+
+    // get inode pointer
+    code = _get_inode_from_path( pathname , &inode );
+
+    if ( code == 2 )  
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_open() : path to parent not found"
+                " for file <%s>\n", pathname );
+        return -2;
+    }
+    else if ( code == 3 )  
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_open() : one name in path too long"
+                " for file <%s>\n", pathname );
+        return -3;
+    }
+    else if ( (code == 1) && (create == 0) )   
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_open() : file not found"
+                " for file <%s>\n", pathname );
+        return -4;
+    }
+    else if ( (code == 1) && (create != 0) )   // file name not found => create 
+    {
+        // set parent inode pointer
+        parent = inode;
 
 #if GIET_DEBUG_FAT
 if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _scan_directory() : P[%d,%d,%d] found %s"
-        " : cluster = %x\n", x, y, p, file_name, searched_cluster );
-#endif
-
-    return searched_cluster;
-} // end _scan_directory()
-
-
-//////////////////////////////////////////////////////////////////////
-// This function create a new entry in a directory identified 
-// by "dir_cluster". The name is defined by "name".
-// The type (dir/file) is defined by "is_file".
-// Returns cluster index if success, Returns -1 if error.
-//////////////////////////////////////////////////////////////////////
-static int _fat_create( char*           name,
-                        unsigned int    is_file,
-                        unsigned int    dir_cluster )
-{
-    _printf("\n[FAT ERROR] _fat_create() not implemented\n");
+_printf("\n[DEBUG FAT] _fat_open() : P[%d,%d,%d] create a new file <%s>\n",
+        x , y , p , pathname );
+#endif
+
+        // get new file name / error check already done by _get_inode_from_path()
+        char name[32];        
+        _get_last_name( pathname , name );
+
+        // allocate a new inode and an empty Cache-File 
+        child = _allocate_one_inode( name,
+                                     0,                         // not a directory
+                                     END_OF_CHAIN_CLUSTER_MAX,  // no cluster allocated
+                                     0,                         // size : new file is empty
+                                     0,                         // count incremented later
+                                     0,                         // dentry set by add_dir_entry
+                                     1 );                       // cache_allocate
+
+        // introduce inode into Inode-Tree
+        _add_inode_in_tree( child , parent );
+
+        // add an entry in the parent directory Cache_file
+        if ( _add_dir_entry( child , parent ) )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_open() : cannot update parent directory"
+                    " for file <%s>\n" , pathname );
+            return -5;
+        } 
+
+        // update DATA region on block device for parent directory
+        if ( _update_device_from_cache( parent->levels,
+                                        parent->cache,
+                                        parent->name ) )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_open() : cannot update DATA region "
+                    " for parent of file <%s>\n", pathname );
+            return -6;
+        }
+
+        // update FAT region on block device
+        if ( _update_device_from_cache( _fat.fat_cache_levels,
+                                        _fat.fat_cache_root,
+                                        "FAT" ) )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_open() : cannot update FAT region"
+                    " for file <%s>\n", pathname );
+            return -7;
+        }
+
+        // update FS_INFO sector
+        if ( _update_fs_info() )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_open() : cannot update FS-INFO"
+                    " for file <%s>\n", pathname );
+            return -8;
+        }
+    }
+    else // code == 0
+    {
+        // set searched file inode pointer
+        child = inode;
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_open() : P[%d,%d,%d] found file <%s> on device : inode = %x\n",
+        x , y , p , pathname , child );
+#endif
+
+    }
+
+    // Search an empty slot in file descriptors array
+    fd_id = 0;
+    while ( (_fat.fd[fd_id].allocated) != 0 && (fd_id < GIET_OPEN_FILES_MAX) )
+    {
+        fd_id++;
+    }
+
+    // set file descriptor if an empty slot has been found
+    if ( fd_id < GIET_OPEN_FILES_MAX )
+    {
+        // update file descriptor
+        _fat.fd[fd_id].allocated  = 1;
+        _fat.fd[fd_id].seek       = 0;
+        _fat.fd[fd_id].read_only  = read_only;
+        _fat.fd[fd_id].inode      = child;
+
+        // increment the refcount
+        child->count = child->count + 1;
+
+        // releases the lock
+        _spin_lock_release( &_fat.fat_lock );
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_open() : P[%d,%d,%d] got fd = %d for <%s> / "
+        "read_only = %d\n",
+        x , y , p , fd_id , pathname , read_only );
+#endif
+        return fd_id;
+    }
+    else
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_open() : File-Descriptors-Array full\n");
+        return -9;
+    }
+} // end _fat_open()
+
+
+
+
+/////////////////////////////////////////////////////////////////////////////////
+// This function implements the "giet_fat_close()" system call.
+// It decrements the inode reference count, and release the fd_id entry
+// in the file descriptors array.
+// If the reference count is zero, it writes all dirty clusters on block device, 
+// and releases the memory allocated to the file_cache: The cache 64-Tree
+// infrastructure (depending on file size) is kept, but all buffers and all
+// buffer descriptors are released.
+/////////////////////////////////////////////////////////////////////////////////
+// Returns 0 on success.
+// Returns negative value if error:
+//  -1  : "FAT not initialised"
+//  -2  : "Illegal file descriptor"
+//  -3  : "Cannot update DATA region for closed file"
+//  -4  : "Cannot release memory"
+/////////////////////////////////////////////////////////////////////////////////
+int _fat_close( unsigned int fd_id )
+{
+    // checking FAT initialised
+    if( _fat.initialised != FAT_INITIALISED )
+    {
+        _printf("\n[FAT ERROR] in _fat_close() : FAT not initialised\n");
+        return -1;
+    }
+
+    if( (fd_id >= GIET_OPEN_FILES_MAX) )
+    {
+        _printf("\n[FAT ERROR] in _fat_close() : illegal file descriptor index\n");
+        return -2;
+    } 
+
+    // takes lock
+    _spin_lock_acquire( &_fat.fat_lock );
+
+    // get the inode pointer 
+    fat_inode_t*  inode = _fat.fd[fd_id].inode;
+
+    // decrement reference count
+    inode->count = inode->count - 1;
+    
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[FAT DEBUG] _fat_close() for file <%s> : refcount = %d\n",
+        inode->name , inode->count );
+#endif
+
+    // update block device and release File-Cache if no more references
+    if ( inode->count == 0 )
+    {
+        // update all dirty clusters for closed file
+        if ( _update_device_from_cache( inode->levels, 
+                                        inode->cache,
+                                        inode->name ) ) 
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_close() : cannot write dirty clusters "
+                    "for file <%s>\n", inode->name );
+            return -3;
+        }
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[FAT DEBUG] _fat_close() update device for file <%s>\n", inode->name );
+#endif
+
+        // update directory dirty clusters for parent directory
+        if ( _update_device_from_cache( inode->parent->levels, 
+                                        inode->parent->cache,
+                                        inode->parent->name ) ) 
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_close() : cannot write dirty clusters "
+                    "for directory <%s>\n", inode->parent->name );
+            return -4;
+        }
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[FAT DEBUG] _fat_close() update device for parent directory <%s>\n",
+        inode->parent->name );
+#endif
+
+        // release memory allocated to File-Cache
+        if ( _release_cache_memory( inode->cache,
+                                    inode-> levels ) )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_close() : cannot release cache memory "
+                    "for file <%s>\n", _fat.fd[fd_id].inode->name );
+            return -5;
+        }
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[FAT DEBUG] _fat_close() release memory for File-Cache <%s>\n",
+        inode->name );
+#endif
+
+    }
+
+    // release fd_id entry in file descriptor array
+    _fat.fd[fd_id].allocated = 0;
+
+    // release lock
+    _spin_lock_release( &_fat.fat_lock );
+
     return 0;
-}  //end _fat_create()
-
-
-
-////////////// Extern functions //////////////////////////////////////////
-
-//////////////////////////////////////////////////////////////////////////
-// This function initializes the FAT structure, including the open
-// files descriptors array and the lock protecting the FAT,
-// from informations found in the boot record.
-// This should be done only once.
-//////////////////////////////////////////////////////////////////////////
-// Return 0 if success, exit if failure 
-//////////////////////////////////////////////////////////////////////////
-int _fat_init( unsigned int use_irq )  
-{
+} // end fat_close()
+
+
+
+
+/////////////////////////////////////////////////////////////////////////////////
+// This function implements the giet_fat_file_info() system call.
+// It returns the size and the current offset value for a file identified 
+// by the "fd_id" argument. 
+/////////////////////////////////////////////////////////////////////////////////
+// Returns  0 if success.
+// Returns negative value if error.
+//  -1  : "FAT not initialised"
+//  -2  : "Illegal file descriptor"
+//  -3  : "File not open"
+/////////////////////////////////////////////////////////////////////////////////
+int _fat_file_info( unsigned int   fd_id,
+                    unsigned int*  size,
+                    unsigned int*  offset )
+{
+    // checking FAT initialised
+    if( _fat.initialised != FAT_INITIALISED )
+    {
+        _printf("\n[FAT ERROR] in _fat_file_info() : FAT not initialised\n");
+        return -1;
+    }
+
+
+    if( fd_id >= GIET_OPEN_FILES_MAX )
+    {
+        _printf("\n[FAT ERROR] in _fat_file_info() : illegal file descriptor index\n");
+        return -2;
+    } 
+
+    if ( _fat.fd[fd_id].allocated == 0 )
+    {
+        _printf("\n[FAT ERROR] in _fat_file_info() : file <%s> not open\n",
+                _fat.fd[fd_id].inode->name );
+        return -3;
+    }
+
+    *size   = _fat.fd[fd_id].inode->size;
+    *offset = _fat.fd[fd_id].seek;  
+    return 0;
+
+} // end _fat_file_info()
+
+
+
+
+/////////////////////////////////////////////////////////////////////////////////
+// The following function implements the "giet_fat_read()" system call.
+// It transfers "count" bytes from the File_Cache associated to the file
+// identified by "fd_id", to the user "buffer", from the current file offset.
+// It has the same semantic as the UNIX "read()" function.
+// In case of miss in the File_Cache, it loads all involved clusters into cache.
+/////////////////////////////////////////////////////////////////////////////////
+// Returns number of bytes actually transfered if success .
+// Returns 0 if EOF encountered (offset + count > file_size). 
+// Returns a negative value if error:
+//   -1 :  "fat not initialised"
+//   -2 :  "file not open"
+//   -3 :  "cannot load file from device"
+/////////////////////////////////////////////////////////////////////////////////
+int _fat_read( unsigned int fd_id,     // file descriptor index
+               void*        buffer,    // destination buffer
+               unsigned int count )    // number of bytes to read
+{
+    // checking FAT initialised
+    if( _fat.initialised != FAT_INITIALISED )
+    {
+        _printf("\n[FAT ERROR] in _fat_write() : FAT not initialised\n");
+        return -1;
+    }
+
+    // check fd_id overflow
+    if ( fd_id >= GIET_OPEN_FILES_MAX )
+    {
+        _printf("\n[FAT ERROR] in _fat_read() : illegal file descriptor\n");
+        return -1;
+    }
+
+    // check file is open
+    if ( _fat.fd[fd_id].allocated == 0 )
+    {
+        _printf("\n[FAT ERROR] in _fat_read() : file not open\n");
+        return -2;
+    }
+
+    // takes lock
+    _spin_lock_acquire( &_fat.fat_lock );
+           
+    // get file inode pointer and offset
+    fat_inode_t* inode  = _fat.fd[fd_id].inode;
+    unsigned int seek   = _fat.fd[fd_id].seek;
+
+    // check count & seek versus file size
+    if ( count + seek > inode->size )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_read() : file too small"
+                " / seek = %x / count = %x / file_size = %x\n",
+                seek , count , inode->size );
+        return 0;
+    }
+
+    // compute first_cluster_id and first_byte_to_move 
+    unsigned int first_cluster_id   = seek >> 12;
+    unsigned int first_byte_to_move = seek & 0xFFF;   
+
+    // compute last_cluster and last_byte_to_move 
+    unsigned int last_cluster_id   = (seek + count - 1) >> 12;   
+    unsigned int last_byte_to_move = (seek + count - 1) & 0xFFF;
 
 #if GIET_DEBUG_FAT
@@ -1148,126 +3133,147 @@
 unsigned int p       = procid & ((1<<P_WIDTH)-1);
 if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] P[%d,%d,%d] enters _fat_init\n",x,y,p);
-#endif
-
-    // FAT initialisation should be done only once
-    if ( _fat.initialised == FAT_INITIALISED )
-    {
-        _printf("\n[FAT ERROR] Strange, FAT already initialised...\n");
-        _exit();
-    }
-
-    // load Boot Record (VBR) into fat cache
-    if ( _fat_ioc_access( use_irq,
-                          1,                   // read
-                          0,                   // sector index
-                          (unsigned int)_fat.fat_cache,
-                          1 ) )                // one sector
-    {
-        _printf("\n[FAT ERROR] in _fat_init() cannot load VBR\n");
-        _exit();
-    }
-    _fat.cache_lba = 0;
-
-#if GIET_DEBUG_FAT > 1
-if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _fat_init() : Boot Sector Loaded\n");
-if ( (_get_proctime() > GIET_DEBUG_FAT) && (GIET_DEBUG_FAT & 0x1) )
-_display_fat_cache();
-#endif
-
-    // checking various FAT32 assuptions from boot sector
-    if( _read_entry( BPB_BYTSPERSEC, _fat.fat_cache, 1 ) != 512 )
-    {
-        _printf("\n[FAT ERROR] The sector size must be 512 bytes\n");
-        _exit();
-    }
-    if( _read_entry( BPB_NUMFATS, _fat.fat_cache, 1 ) != 1 )
-    {
-        _printf("\n[FAT ERROR] The number of FAT copies in FAT region must be 1\n");
-        _exit();
-    }
-    if( (_read_entry( BPB_FAT32_FATSZ32, _fat.fat_cache, 1 ) & 0xF) != 0 )
-    {
-        _printf("\n[FAT ERROR] The FAT region must be multiple of 32 sectors\n");
-        _exit();
-    }
-    if( _read_entry( BPB_FAT32_ROOTCLUS, _fat.fat_cache, 1 ) != 2 )
-    {
-        _printf("\n[FAT ERROR] The first cluster index must be 2\n");
-        _exit();
-    }
-    // FS Info always in sector 1
-    _fat.fs_info_lba         = _read_entry( BPB_FAT32_FSINFO, _fat.fat_cache, 1 );
-
-    // initialise fat descriptor from VBR
-    _fat.sectors_per_cluster = _read_entry( BPB_SECPERCLUS, _fat.fat_cache, 1 );
-    _fat.sector_size         = _read_entry( BPB_BYTSPERSEC, _fat.fat_cache, 1 );
-    _fat.cluster_size        = _fat.sectors_per_cluster * 512;
-    _fat.fat_sectors         = _read_entry( BPB_FAT32_FATSZ32, _fat.fat_cache, 1 );
-    _fat.fat_lba             = _read_entry( BPB_RSVDSECCNT, _fat.fat_cache, 1 );
-    _fat.data_lba            = _fat.fat_lba + _fat.fat_sectors;
-    _fat.initialised         = FAT_INITIALISED;
-
-    // initalise the lock protecting the FAT
-    _spin_lock_init( &_fat.fat_lock );
-
-    // initialise file descriptor array
-    unsigned int   n;
-    for( n = 0 ; n < GIET_OPEN_FILES_MAX ; n++ ) _fat.fd[n].used = 0;
+_printf("\n[DEBUG FAT] _fat_read() : P[%d,%d,%d] enters for file <%s> "
+        " / bytes = %x / offset = %x\n"
+        "first_cluster_id = %x / first_byte_to_move = %x"
+        " / last_cluster_id = %x / last_byte_to_move = %x\n",
+        x , y , p , inode->name , count , seek ,
+        first_cluster_id , first_byte_to_move , last_cluster_id , last_byte_to_move );
+#endif
+
+    // loop on all cluster covering the requested transfer
+    unsigned int cluster_id;
+    unsigned int done = 0;
+    for ( cluster_id = first_cluster_id ; cluster_id <= last_cluster_id ; cluster_id++ )
+    {
+        // get pointer on the cluster_id buffer in cache 
+        unsigned char*     cbuf;
+        fat_cache_desc_t*  pdesc;
+        if ( _get_buffer_from_cache( inode, 
+                                     cluster_id,
+                                     &pdesc ) )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_read() : cannot load file <%s>\n",
+                    inode->name );
+            return -3;
+        }
+        cbuf = pdesc->buffer;
 
 #if GIET_DEBUG_FAT
 if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _fat_init() : FS_INFO Sector = %x\n", _fat.fs_info_lba );
-#endif
-
-    // load FS_INFO into fat cache
-    if ( _fat_ioc_access( use_irq,
-                          1,                  // read
-                          _fat.fs_info_lba,    
-                          (unsigned int)_fat.fat_cache,
-                          1 ) )               // one sector
-    { 
-        _printf("\n[FAT ERROR] in _fat_init() cannot load FS_INFO Sector\n"); 
-        _exit();
-    }
-    _fat.cache_lba = _fat.fs_info_lba;
-
-    _fat.number_free_cluster    = _read_entry( FS_FREE_CLUSTER     , _fat.fat_cache, 1);
-    _fat.last_cluster_allocated = _read_entry( FS_FREE_CLUSTER_HINT, _fat.fat_cache, 1);
+_printf("\n[DEBUG FAT] _fat_read() : P[%d,%d,%d] moves cluster_id %d from Cache-File <%s>\n",
+        x , y , p , cluster_id, inode->name );
+#endif
+
+        // compute memcpy arguments
+        unsigned char*  source;
+        unsigned int    nbytes;
+        unsigned char*  dest = (unsigned char*)buffer + done;
+        if ( (cluster_id == first_cluster_id) && (cluster_id == last_cluster_id) )
+        {
+            source = cbuf + first_byte_to_move; 
+            nbytes = last_byte_to_move - first_byte_to_move + 1;
+        }
+        else if ( cluster_id == first_cluster_id )
+        {
+            source = cbuf + first_byte_to_move; 
+            nbytes = 4096 - first_byte_to_move;
+        }
+        else if ( cluster_id == last_cluster_id )
+        {
+            source = cbuf; 
+            nbytes = last_byte_to_move + 1;
+        }
+        else  // not first / not last
+        {
+            source = cbuf; 
+            nbytes = 4096;
+        }
+
+        // move data
+        memcpy( dest , source , nbytes );
+        done = done + nbytes;
+    }
 
 #if GIET_DEBUG_FAT
 if ( _get_proctime() > GIET_DEBUG_FAT )
-_fat_print();
-_printf("\n[DEBUG FAT] P[%d,%d,%d] exit _fat_init()\n", x,y,p );
-#endif
-
-    return 0;
-}  // end _fat_init()
-
-///////////////////////////////////////////////////////////////////////////////
-// This function checks that the kernel FAT structure has been initialised.
-// It searches a file identified by the "pathname" argument.
-// It starts from root (cluster 2) to scan successively each subdirectory.
-// When the file is not found, but the path is found, and "creat" is set,
-// a new file is created and introduced in the directory.
-// Finally, it sets a new open file in the file descriptors array.
-// The same file can be open several times by differents tasks.
-///////////////////////////////////////////////////////////////////////////////
-// Returns file descriptor index if success, returns -1 if error.
-///////////////////////////////////////////////////////////////////////////////
-int _fat_open( unsigned int use_irq,       // use descheduling mode if possible
-               char*        pathname,
-               unsigned int creat )
-{
-    char                 name[256];        // buffer for one name in pathname
-    unsigned int         nb_read;	       // number of characters written in name[] 
-    unsigned int         cluster;          // current cluster index when scanning FAT
-    unsigned int         dir_cluster;      // previous cluster index when scanning FAT
-    unsigned int         fd_id;            // index when scanning file descriptors array
-    unsigned int         file_size = 0;    // number of bytes
-    unsigned int         last_name = 0;    // directory containing file name is reached
-    unsigned int         lba       = 0;    // lba of dir_entry for this file
-    
+_printf("\n[DEBUG FAT] _fat_read() : P[%d,%d,%d] loaded file <%s> from Cache-File\n",
+        x , y , p , inode->name );
+#endif
+
+    // update seek
+    _fat.fd[fd_id].seek += done;
+
+    // release lock
+    _spin_lock_release( &_fat.fat_lock );
+
+    return done;
+} // end _fat_read()
+
+
+
+
+/////////////////////////////////////////////////////////////////////////////////
+// The following function implements the "giet_fat_write()" system call.
+// It transfers "count" bytes to the fat_cache associated to the file
+// identified by "fd_id", from the user "buffer", using the current file offset.
+// It has the same semantic as the UNIX "write()" function.
+// It increases the file size and allocate new clusters if (count + offset) 
+// is larger than the current file size. Then it loads and updates all 
+// involved clusters in the cache.
+/////////////////////////////////////////////////////////////////////////////////
+// Returns number of bytes actually written if success.
+// Returns a negative value if error:
+//   -1 :  "FAT not initialised"
+//   -2 :  "Illegal file descriptor"
+//   -3 :  "File not open"
+//   -4 :  "File not writable"
+//   -5 :  "No free clusters"
+//   -6 :  "Cannot update parent directory entry"
+//   -7 :  "Cannot access File-Cache"
+/////////////////////////////////////////////////////////////////////////////////
+int _fat_write( unsigned int fd_id,    // file descriptor index
+                void*        buffer,   // source buffer
+                unsigned int count )   // number of bytes to write
+{
+    // checking FAT initialised
+    if( _fat.initialised != FAT_INITIALISED )
+    {
+        _printf("\n[FAT ERROR] in _fat_write() : FAT not initialised\n");
+        return -1;
+    }
+
+    // takes lock
+    _spin_lock_acquire( &_fat.fat_lock );
+           
+    // check fd_id overflow
+    if ( fd_id >= GIET_OPEN_FILES_MAX )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_write() : illegal file descriptor\n");
+        return -2;
+    }
+
+    // check file open
+    if ( _fat.fd[fd_id].allocated == 0 )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_write() : file not open\n" );
+        return -3;
+    }
+
+    // check file writable
+    if ( _fat.fd[fd_id].read_only )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_write() : file <%s> is read-only\n",
+                _fat.fd[fd_id].inode->name );
+        return -4;
+    }
+
+    // get file inode pointer and seek 
+    fat_inode_t* inode  = _fat.fd[fd_id].inode;
+    unsigned int seek   = _fat.fd[fd_id].seek;
+
 #if GIET_DEBUG_FAT
 unsigned int procid  = _get_procid();
